%global momorel 2
%global debug_package %{nil}

Summary: Kernel-based Virtual Machine
Name: kvm
Version: 68
Release: %{momorel}m%{?dist}
License: GPL
Group: Development/Tools
URL: http://kvm.sf.net
Source0: http://dl.sourceforge.net/sourceforge/kvm/kvm-%{version}.tar.gz 
NoSource: 0
Source1: %{name}.modules
Patch0: kvm-63-defaults.patch
Patch1: %{name}-bootmenu.patch
Patch2: %{name}-62-block-rw-range-check.patch
Patch3: %{name}-62-e1000-default.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: SDL-devel 
# qemu doesn't build with gcc 4.x
BuildRequires: gcc3.4
BuildRequires: gnutls-devel >= 2.4.1
BuildRequires: zlib-devel 
BuildRequires: e2fsprogs-devel
BuildRequires: dev86
BuildRequires: iasl
# for the docs
BuildRequires: texi2html
# kvm kernel side is only x86/x86_64 as that's where the hardware is
ExclusiveArch: %{ix86} x86_64

%description
KVM (for Kernel-based Virtual Machine) is a full virtualization solution 
for Linux on x86 hardware. 

Using KVM, one can run multiple virtual machines running unmodified Linux 
or Windows images. Each virtual machine has private virtualized hardware: 
a network card, disk, graphics adapter, etc.

%prep
%setup -q
#patch0 -p1
%patch1 -p1
%patch2 -p1
#patch3 -p1


%build
# we need to install the data bits in a different path
sed -i 's/datasuffix=\"\/share\/qemu\"/datasuffix=\"\/share\/kvm\"/' qemu/configure
./configure --with-patched-kernel --qemu-cc=gcc_3_4 --kerneldir=$(pwd)/kernel --prefix=%{_prefix} --qemu-ldflags="-Wl,--build-id" --enable-alsa

# we can't use RPM_OPT_FLAGS for the same reasons as qemu (#208026) for the
# qemu bits.  so let's set it for the other pieces.  this requires some
# manual keeping up of what is in the kvm tree.
sed -i 's/CFLAGS =/CFLAGS +=/' user/Makefile
echo "CFLAGS=$RPM_OPT_FLAGS" >> user/config.mak
make %{?_smp_mflags} 


%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

# we have to have our own copies of the bios/keymaps due to incompat with
# qemu 0.9.  include the man page
mv $RPM_BUILD_ROOT/%{_mandir}/man1/qemu.1* $RPM_BUILD_ROOT/%{_mandir}/man1/qemu-kvm.1
rm -rf $RPM_BUILD_ROOT/%{_mandir}/man*/qemu-img* $RPM_BUILD_ROOT/%{_docdir}
rm -f $RPM_BUILD_ROOT/%{_bindir}/qemu-img
# no shared lib, static libs
rm -fr $RPM_BUILD_ROOT/%{_includedir} $RPM_BUILD_ROOT/%{_libdir}

# make install gives it bogus execute permissiions
chmod -x $RPM_BUILD_ROOT/%{_mandir}/man1/qemu-kvm.1*

# We're only build x86, so kill other BIOS to save disk space
rm -f $RPM_BUILD_ROOT/%{_datadir}/%{name}/openbios-sparc32
rm -f $RPM_BUILD_ROOT/%{_datadir}/%{name}/ppc_rom.bin
rm -f $RPM_BUILD_ROOT/%{_datadir}/%{name}/video.x

mv $RPM_BUILD_ROOT/%{_bindir}/qemu* $RPM_BUILD_ROOT/%{_bindir}/qemu-kvm

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/modules
install -m 0755 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/modules/kvm.modules

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_bindir}/qemu-kvm
%{_mandir}/man*/*
%{_datadir}/kvm
%{_sysconfdir}/sysconfig/modules/%{name}.modules

%changelog
* Tue Jul 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (68-2m)
- rebuild against gnutls-2.4.1

* Tue May  6 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (68-1m)
- update 68

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (60-3m)
- rebuild against gcc43

* Thu Feb 14 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (60-2m)
- %%NoSource -> NoSource

* Fri Jan 25 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (60-1m)
- update 60

* Thu Dec  6 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (55-1m)
- update 55

* Sun Sep 23 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (33-2m)
- disabled debug_package

* Tue Jul 31 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (33-1m)
- update 33

* Tue Jul 17 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (29-1m)
- update 29

* Tue Jun 12 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (28-1m)
- update 28
- use gcc3.4

* Fri Apr 13 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (15-1m)
- import from fc to Momonga
- Momonga use gcc_3_2 (! gcc3.4)

* Wed Mar  7 2007 Jeremy Katz <katzj@redhat.com> - 15-1
- update to kvm-15

* Mon Feb 26 2007 Jeremy Katz <katzj@redhat.com> - 14-2
- use default optflags for non-qemu pieces (#230012)

* Fri Feb 23 2007 Jeremy Katz <katzj@redhat.com> - 14-1
- update to kvm-14
- note: this requires a kernel that's 2.6.21-rc1 or newer

* Mon Feb 19 2007 Jeremy Katz <katzj@redhat.com> - 12-3
- add the buildrequires for the docs to build

* Mon Feb 19 2007 Jeremy Katz <katzj@redhat.com> - 12-2
- include bios and keymaps in the kvm package since we need a slightly 
  different version for kvm now
- include man page

* Fri Jan 26 2007 Jeremy Katz <katzj@redhat.com> - 12-1
- update to kvm-12
- add qemu patch for better ATAPI DMA support (which works with ata_piix)

* Fri Jan 19 2007 Jeremy Katz <katzj@redhat.com> - 11-1
- update to kvm-11

* Fri Jan  5 2007 Jeremy Katz <katzj@redhat.com> - 9-1
- update to kvm-9

* Wed Jan  3 2007 Jeremy Katz <katzj@redhat.com> - 7-4
- actually build without -devel...

* Wed Dec 20 2006 Jeremy Katz <katzj@redhat.com> - 7-3
- remove the -devel subpackage since there's no shared lib upstream yet
- direct download link for source 

* Tue Dec 19 2006 Jeremy Katz <katzj@redhat.com> - 7-2
- BR e2fsprogs-devel

* Tue Dec 19 2006 Jeremy Katz <katzj@redhat.com> - 7-1
- Initial build 

